import{s as we,n as Ce,o as Le}from"../chunks/scheduler.8c3d61f6.js";import{S as Oe,i as ke,g as a,s as n,r as p,A as Ie,h as d,f as t,c as o,j as x,u,x as y,k as P,y as s,a as c,v as m,d as f,t as h,w as g}from"../chunks/index.da70eac4.js";import{D as W}from"../chunks/Docstring.6b390b9a.js";import{H as Se,E as qe}from"../chunks/EditOnGithub.1e64e623.js";function He(be){let _,j,G,K,E,Y,M,De='The <code>DPMSolverSDEScheduler</code> is inspired by the stochastic sampler from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper, and the scheduler is ported from and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',J,T,Q,i,w,de,N,$e=`DPMSolverSDEScheduler implements the stochastic sampler from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based
Generative Models</a> paper.`,le,F,xe=`This model inherits from <a href="/docs/diffusers/v0.32.1/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/v0.32.1/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,ce,S,C,pe,U,ye=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,ue,b,L,me,V,Pe="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",fe,D,O,he,z,Ee="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",ge,$,k,_e,A,Me=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,X,I,Z,v,q,ve,B,Te="Base class for the output of a scheduler’s <code>step</code> function.",ee,H,te,R,se;return E=new Se({props:{title:"DPMSolverSDEScheduler",local:"dpmsolversdescheduler",headingTag:"h1"}}),T=new Se({props:{title:"DPMSolverSDEScheduler",local:"diffusers.DPMSolverSDEScheduler",headingTag:"h2"}}),w=new W({props:{name:"class diffusers.DPMSolverSDEScheduler",anchor:"diffusers.DPMSolverSDEScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": typing.Union[numpy.ndarray, typing.List[float], NoneType] = None"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"use_karras_sigmas",val:": typing.Optional[bool] = False"},{name:"use_exponential_sigmas",val:": typing.Optional[bool] = False"},{name:"use_beta_sigmas",val:": typing.Optional[bool] = False"},{name:"noise_sampler_seed",val:": typing.Optional[int] = None"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.DPMSolverSDEScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.00085) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.DPMSolverSDEScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.012) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.DPMSolverSDEScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.DPMSolverSDEScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.DPMSolverSDEScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.DPMSolverSDEScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.DPMSolverSDEScheduler.use_exponential_sigmas",description:`<strong>use_exponential_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use exponential sigmas for step sizes in the noise schedule during the sampling process.`,name:"use_exponential_sigmas"},{anchor:"diffusers.DPMSolverSDEScheduler.use_beta_sigmas",description:`<strong>use_beta_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use beta sigmas for step sizes in the noise schedule during the sampling process. Refer to <a href="https://huggingface.co/papers/2407.12173" rel="nofollow">Beta
Sampling is All You Need</a> for more information.`,name:"use_beta_sigmas"},{anchor:"diffusers.DPMSolverSDEScheduler.noise_sampler_seed",description:`<strong>noise_sampler_seed</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The random seed to use for the noise sampler. If <code>None</code>, a random seed is generated.`,name:"noise_sampler_seed"},{anchor:"diffusers.DPMSolverSDEScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.DPMSolverSDEScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/v0.32.1/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L161"}}),C=new W({props:{name:"scale_model_input",anchor:"diffusers.DPMSolverSDEScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"timestep",val:": typing.Union[float, torch.Tensor]"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.DPMSolverSDEScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/v0.32.1/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L309",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),L=new W({props:{name:"set_begin_index",anchor:"diffusers.DPMSolverSDEScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/v0.32.1/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L299"}}),O=new W({props:{name:"set_timesteps",anchor:"diffusers.DPMSolverSDEScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": typing.Union[str, torch.device] = None"},{name:"num_train_timesteps",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.DPMSolverSDEScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/v0.32.1/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L336"}}),k=new W({props:{name:"step",anchor:"diffusers.DPMSolverSDEScheduler.step",parameters:[{name:"model_output",val:": typing.Union[torch.Tensor, numpy.ndarray]"},{name:"timestep",val:": typing.Union[float, torch.Tensor]"},{name:"sample",val:": typing.Union[torch.Tensor, numpy.ndarray]"},{name:"return_dict",val:": bool = True"},{name:"s_noise",val:": float = 1.0"}],parametersDescription:[{anchor:"diffusers.DPMSolverSDEScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code> or <code>np.ndarray</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DPMSolverSDEScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code> or <code>torch.Tensor</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.DPMSolverSDEScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code> or <code>np.ndarray</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.DPMSolverSDEScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <code>DPMSolverSDESchedulerOutput</code> or
tuple.`,name:"return_dict"},{anchor:"diffusers.DPMSolverSDEScheduler.step.s_noise",description:`<strong>s_noise</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
Scaling factor for noise added to the sample.`,name:"s_noise"}],source:"https://github.com/huggingface/diffusers/blob/v0.32.1/src/diffusers/schedulers/scheduling_dpmsolver_sde.py#L526",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <code>DPMSolverSDESchedulerOutput</code> is
returned, otherwise a tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>DPMSolverSDESchedulerOutput</code> or <code>tuple</code></p>
`}}),I=new Se({props:{title:"SchedulerOutput",local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",headingTag:"h2"}}),q=new W({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": Tensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.32.1/src/diffusers/schedulers/scheduling_utils.py#L60"}}),H=new qe({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/dpm_sde.md"}}),{c(){_=a("meta"),j=n(),G=a("p"),K=n(),p(E.$$.fragment),Y=n(),M=a("p"),M.innerHTML=De,J=n(),p(T.$$.fragment),Q=n(),i=a("div"),p(w.$$.fragment),de=n(),N=a("p"),N.innerHTML=$e,le=n(),F=a("p"),F.innerHTML=xe,ce=n(),S=a("div"),p(C.$$.fragment),pe=n(),U=a("p"),U.textContent=ye,ue=n(),b=a("div"),p(L.$$.fragment),me=n(),V=a("p"),V.textContent=Pe,fe=n(),D=a("div"),p(O.$$.fragment),he=n(),z=a("p"),z.textContent=Ee,ge=n(),$=a("div"),p(k.$$.fragment),_e=n(),A=a("p"),A.textContent=Me,X=n(),p(I.$$.fragment),Z=n(),v=a("div"),p(q.$$.fragment),ve=n(),B=a("p"),B.innerHTML=Te,ee=n(),p(H.$$.fragment),te=n(),R=a("p"),this.h()},l(e){const r=Ie("svelte-u9bgzb",document.head);_=d(r,"META",{name:!0,content:!0}),r.forEach(t),j=o(e),G=d(e,"P",{}),x(G).forEach(t),K=o(e),u(E.$$.fragment,e),Y=o(e),M=d(e,"P",{"data-svelte-h":!0}),y(M)!=="svelte-f261ri"&&(M.innerHTML=De),J=o(e),u(T.$$.fragment,e),Q=o(e),i=d(e,"DIV",{class:!0});var l=x(i);u(w.$$.fragment,l),de=o(l),N=d(l,"P",{"data-svelte-h":!0}),y(N)!=="svelte-2gqyak"&&(N.innerHTML=$e),le=o(l),F=d(l,"P",{"data-svelte-h":!0}),y(F)!=="svelte-934yx5"&&(F.innerHTML=xe),ce=o(l),S=d(l,"DIV",{class:!0});var re=x(S);u(C.$$.fragment,re),pe=o(re),U=d(re,"P",{"data-svelte-h":!0}),y(U)!=="svelte-1rkfgpx"&&(U.textContent=ye),re.forEach(t),ue=o(l),b=d(l,"DIV",{class:!0});var ne=x(b);u(L.$$.fragment,ne),me=o(ne),V=d(ne,"P",{"data-svelte-h":!0}),y(V)!=="svelte-1k141rk"&&(V.textContent=Pe),ne.forEach(t),fe=o(l),D=d(l,"DIV",{class:!0});var oe=x(D);u(O.$$.fragment,oe),he=o(oe),z=d(oe,"P",{"data-svelte-h":!0}),y(z)!=="svelte-1vzm9q"&&(z.textContent=Ee),oe.forEach(t),ge=o(l),$=d(l,"DIV",{class:!0});var ie=x($);u(k.$$.fragment,ie),_e=o(ie),A=d(ie,"P",{"data-svelte-h":!0}),y(A)!=="svelte-hi84tp"&&(A.textContent=Me),ie.forEach(t),l.forEach(t),X=o(e),u(I.$$.fragment,e),Z=o(e),v=d(e,"DIV",{class:!0});var ae=x(v);u(q.$$.fragment,ae),ve=o(ae),B=d(ae,"P",{"data-svelte-h":!0}),y(B)!=="svelte-6ojmkw"&&(B.innerHTML=Te),ae.forEach(t),ee=o(e),u(H.$$.fragment,e),te=o(e),R=d(e,"P",{}),x(R).forEach(t),this.h()},h(){P(_,"name","hf:doc:metadata"),P(_,"content",Ne),P(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(i,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),P(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){s(document.head,_),c(e,j,r),c(e,G,r),c(e,K,r),m(E,e,r),c(e,Y,r),c(e,M,r),c(e,J,r),m(T,e,r),c(e,Q,r),c(e,i,r),m(w,i,null),s(i,de),s(i,N),s(i,le),s(i,F),s(i,ce),s(i,S),m(C,S,null),s(S,pe),s(S,U),s(i,ue),s(i,b),m(L,b,null),s(b,me),s(b,V),s(i,fe),s(i,D),m(O,D,null),s(D,he),s(D,z),s(i,ge),s(i,$),m(k,$,null),s($,_e),s($,A),c(e,X,r),m(I,e,r),c(e,Z,r),c(e,v,r),m(q,v,null),s(v,ve),s(v,B),c(e,ee,r),m(H,e,r),c(e,te,r),c(e,R,r),se=!0},p:Ce,i(e){se||(f(E.$$.fragment,e),f(T.$$.fragment,e),f(w.$$.fragment,e),f(C.$$.fragment,e),f(L.$$.fragment,e),f(O.$$.fragment,e),f(k.$$.fragment,e),f(I.$$.fragment,e),f(q.$$.fragment,e),f(H.$$.fragment,e),se=!0)},o(e){h(E.$$.fragment,e),h(T.$$.fragment,e),h(w.$$.fragment,e),h(C.$$.fragment,e),h(L.$$.fragment,e),h(O.$$.fragment,e),h(k.$$.fragment,e),h(I.$$.fragment,e),h(q.$$.fragment,e),h(H.$$.fragment,e),se=!1},d(e){e&&(t(j),t(G),t(K),t(Y),t(M),t(J),t(Q),t(i),t(X),t(Z),t(v),t(ee),t(te),t(R)),t(_),g(E,e),g(T,e),g(w),g(C),g(L),g(O),g(k),g(I,e),g(q),g(H,e)}}}const Ne='{"title":"DPMSolverSDEScheduler","local":"dpmsolversdescheduler","sections":[{"title":"DPMSolverSDEScheduler","local":"diffusers.DPMSolverSDEScheduler","sections":[],"depth":2},{"title":"SchedulerOutput","local":"diffusers.schedulers.scheduling_utils.SchedulerOutput","sections":[],"depth":2}],"depth":1}';function Fe(be){return Le(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Be extends Oe{constructor(_){super(),ke(this,_,Fe,He,we,{})}}export{Be as component};
